import java.util.Scanner;

public static void main(String[] args) {

    System.out.println("What time must you be awake? Please use 24-hr format and use a whitespace\n" +
            "character to separate the hour from the minute (H M):"); //prompt user for input
    Scanner scanner = new Scanner(System.in); //create new scanner object to read input from user

    int hours,minutes,newHours; //declaring global variables
    hours = minutes = newHours = 0; //initializing global variables
    // read user input
    try {
        hours = scanner.nextInt();
        minutes = scanner.nextInt();
    }
    catch(Exception e) { //prevents program crash by catching any invalid input
        System.out.println("Invalid input. Please enter integer values only.");
        System.exit(0);
    }

    //Calculate the new time

    if (minutes < 45) {
        newHours = (hours - 1 + 24) % 24; //Modulo handles wrap around for midnight
    }
    else {
        newHours = hours; //when minutes >= 45, the hour stays the same
    }

    int newMinutes = ((minutes - 45) + 60) % 60; //Modulo handles wrap around for minutes

    // output new time
    System.out.print("You should set your alarm for ");
    System.out.printf("%02d:%02d\n", newHours, newMinutes);
    System.out.println("to allow yourself 45 minutes to lay in bed.");

}